#ifndef _MESSAGEQ_H_
#define _MESSAGEQ_H_

#include <list>
#include <iterator>

template<class T>
class CMessageQueue
{
protected:
   std::list<T>  MsgQueue;
   bool     bFull;
   bool     bHasMsg;
   bool     bReorderArray;
   bool     bClosedForSeason;
   
   int          Count;  // waiting threads
   int          Error;  // status flags   
   unsigned int LastMsg;
   
   int  SetHasMsgFlag(bool b);
   bool IsValidMsg(unsigned int);

public:
   pthread_mutex_t busy;
   pthread_cond_t  cond;

   CMessageQueue();
   ~CMessageQueue();

   int WaitOnMsg();
   int WaitOnMsgTO(const timespec *to);

   pthread_cond_t *GetCondition();

   int   GetError();
   int   Add(T *);
   int	AddUnique(T *arg);
   int   Insert(T *, unsigned int pos);
   bool  Peek(unsigned int pos, void *, int len);
   bool  Peek(unsigned int pos, T *);
   bool  GetAt(unsigned int pos, T*);
   bool  GetNext(T *);
   void  DeleteLast();
   unsigned int   GetCount();
   void  RemoveAll();
   void  Delete(unsigned int Num);
   int   CanGrab();
   int   GrabOnMsg();
   int   Grab();
   int   Release();
   void  GoToPub();
   bool  HasMsg();
#ifdef _DEBUGGERY
	int   NumInQueue(){ return MsgQueue.size(); }
#endif   
};

#endif

