/*
plusd.h
Copyright (C)2001 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

   Don't write to me at: kingsley@bananahead.com 

   Part of:
   BhPos, Copyright (C) 2001-2004 Al Kingsley
   BhPos comes with ABSOLUTELY NO WARRANTY.
*/

#ifndef _PLUSERVER_H_
#define _PLUSERVER_H_

#ifndef _BHHDR_H_
#include "pos.h"
#endif

#ifdef BHPOS_WIN32
#include "tsrm_win32.h"
#include "winnt.h"
#ifdef BHPOS_EXPORTS
#define BHPOSAPI __declspec(dllexport)
#else
#define BHPOSAPI __declspec(dllimport)
#endif
#define BHPOS_DIR_SEPARATOR '\\'
#else
#define BHPOSAPI
#define THREAD_LS
#define BHPOS_DIR_SEPARATOR '/'
#endif

#include <list>

#ifndef _TCPTHREAD_
#include "ctcp.h"
#endif

#ifndef BHMODULE_H_
#include "bhmodule.h"
#endif

#ifndef _MODULE_H_
#include "module.h"
#endif

#ifndef _CLIENTINFO_
#include "clientinfo.h"
#endif

#ifndef _CLOCALE_H_
#include "clocale.h"
#endif

#ifndef _BHCLIENTACK_H_
#include "clientack.h"
#endif

/*
#ifndef _BHCCV_
#include "ccv.h"
#endif
*/

#define BH_PLUS_CMD_ERROR_UNKNOWN            0
#define BH_PLUS_CMD_ERROR_CLIENTVERSION      1
#define BH_PLUS_CMD_ERROR_PROTOCOLVERSION    2
#define BH_PLUS_CMD_ERROR_SERVERVERSION      3

// debuggery
#define BH_PLUS_SUBCMD_DEBUG_TICKET    1
#define BH_POST_CONNNECTED             1
#define BH_MODE_DEBUG                  1
#define BH_MODE_VERBOSE                2

// CCV Policy
#define BH_PLUS_POLICY_CCVAUTHNONE   0
#define BH_PLUS_POLICY_CCVAUTHAMOUNT 1
#define BH_PLUS_POLICY_CCVAUTHALL    2

// options
#define BH_PLUS_OPTION_DEBUGLEVEL         1
#define BH_PLUS_OPTION_HOST               2
#define BH_PLUS_OPTION_PORT               3
#define BH_PLUS_OPTION_MCHOST             4
#define BH_PLUS_OPTION_MCPORT             5
#define BH_PLUS_OPTION_LOGLEVEL           6
#define BH_PLUS_OPTION_ERRREDIRECT        7
#define BH_PLUS_OPTION_ERRHOST            8
#define BH_PLUS_OPTION_ERRPORT            9
#define BH_PLUS_OPTION_KEEPALIVE          10
#define BH_PLUS_OPTION_ALIVETIME          11
#define BH_PLUS_OPTION_ALIVERETRIES       12
#define BH_PLUS_OPTION_BASECURRENCYID     13
#define BH_PLUS_OPTION_BASELOCALEID       14
#define BH_PLUS_OPTION_MODULESDIR         15
#define BH_PLUS_OPTION_ADDRESSRANGE       16
#define BH_PLUS_OPTION_FILTERHOSTS        17
#define BH_PLUS_OPTION_LOADMODULES        18
#define BH_PLUS_OPTION_SETDAEMON          19
#define BH_PLUS_OPTION_SETMULTICAST       20
#define BH_PLUS_OPTION_SETTCP             21
#define BH_PLUS_OPTION_SETUDP             22
#define BH_PLUS_OPTION_CACHEPLU           23
#define BH_PLUS_OPTION_CACHELIMIT         24
#define BH_PLUS_OPTION_PRECACHED          25
#define BH_PLUS_OPTION_PRECACHETABLE      26
#define BH_PLUS_OPTION_CLIENTUPSCOLLECT   27
#define BH_PLUS_OPTION_CLIENTUPSPERIOD    28
#define BH_PLUS_OPTION_DBHOSTMULTIPLE     29
#define BH_PLUS_OPTION_DBHOSTPRIME        30
#define BH_PLUS_OPTION_DBDATABASE         31
#define BH_PLUS_OPTION_DBUSER             32
#define BH_PLUS_OPTION_DBPASSWORD         33
#define BH_PLUS_OPTION_DBSQLFILE          34
#define BH_PLUS_OPTION_PLUSUPS            35
#define BH_PLUS_OPTION_NETWORKPLUSUPS     36
#define BH_PLUS_OPTION_UPSHOST            37
#define BH_PLUS_OPTION_UPSPORT            38
#define BH_PLUS_OPTION_UPSPERIOD          39
#define BH_PLUS_OPTION_CLIENTUPS          40
#define BH_PLUS_OPTION_PROTOCOLUDP        42
#define BH_PLUS_OPTION_PROTOCOLTCP        43
#define BH_PLUS_OPTION_BASELOCALESTR      44
#define BH_PLUS_OPTION_INTBCPREFIX        45
#define BH_PLUS_OPTION_WEIGHTBCPREFIX     46
#define BH_PLUS_OPTION_QTYBCPREFIX        47
#define BH_PLUS_OPTION_PRICEBCPREFIX      48
#define BH_PLUS_OPTION_IFBCPREFIX         49
#define BH_PLUS_OPTION_UPSUPDATETIME      50
#define BH_PLUS_OPTION_IDLEUPDATEPERIOD   51
#define BH_PLUS_OPTION_THREADCHECK        52
#define BH_PLUS_OPTION_PROCWRITER         53
#define BH_PLUS_OPTION_RECOMMIT           54
#define BH_PLUS_OPTION_STATSUPDATE        55
#define BH_PLUS_OPTION_CCVHOST            56
#define BH_PLUS_OPTION_CCVPORT            57
#define BH_PLUS_OPTION_CCVUSER            58
#define BH_PLUS_OPTION_CCVPASSWORD        59
#define BH_PLUS_OPTION_CCVSSLHOST         60
#define BH_PLUS_OPTION_CCVSSLPORT         61
#define BH_PLUS_OPTION_CCVCONNTYPES       62
#define BH_PLUS_OPTION_CCVDEFAULTCONN     63
#define BH_PLUS_OPTION_CCVCERTIFICATE     64
#define BH_PLUS_OPTION_CCVAUTHPOLICY      65
#define BH_PLUS_OPTION_CCVAUTHAMOUNT      66
#define BH_PLUS_OPTION_ERRRETRIES         67
#define BH_PLUS_OPTION_ERRTIMEOUT         68
#define BH_PLUS_OPTION_PLUANDPLAY         69
#define BH_PLUS_OPTION_USEDEFCASHD        70
#define BH_PLUS_OPTION_RPHOST             71
#define BH_PLUS_OPTION_RPPORT             72
#define BH_PLUS_OPTION_RPRETRIES          73
#define BH_PLUS_OPTION_RPTIMEOUT          74
#define BH_PLUS_OPTION_PRNSETUP           75
#define BH_PLUS_OPTION_PRNINIT            76
#define BH_PLUS_OPTION_PRNPREPRINT        77
#define BH_PLUS_OPTION_PRNHDR             78
#define BH_PLUS_OPTION_PRNITEM            79
#define BH_PLUS_OPTION_PRNTRANSSUM        80
#define BH_PLUS_OPTION_PRNPAYSUM          81
#define BH_PLUS_OPTION_PRNFOOTER          82
#define BH_PLUS_OPTION_PRNPOSTPRINT       83
#define BH_PLUS_OPTION_JRNPREPRINT        84
#define BH_PLUS_OPTION_JRNITEM            85
#define BH_PLUS_OPTION_JRNPOSTPRINT       86
#define BH_PLUS_OPTION_ENDPREPRINT        87
#define BH_PLUS_OPTION_ENDITEM            88
#define BH_PLUS_OPTION_ENDPOSTPRINT       89
#define BH_PLUS_OPTION_LBLPREPRINT        90
#define BH_PLUS_OPTION_LBLITEM            91
#define BH_PLUS_OPTION_LBLPOSTPRINT       92
#define BH_PLUS_OPTION_SLIPPREPRINT       93
#define BH_PLUS_OPTION_SLIPHEADER         94
#define BH_PLUS_OPTION_SLIPITEM           95
#define BH_PLUS_OPTION_SLIPFOOTER         96
#define BH_PLUS_OPTION_SLIPPOSTPRINT      97
#define BH_PLUS_OPTION_CHKPREPRINT        99
#define BH_PLUS_OPTION_CHKITEM            100
#define BH_PLUS_OPTION_CHKPOSTPRINT       101
#define BH_PLUS_OPTION_MICRPREREAD        102
#define BH_PLUS_OPTION_MICRREAD           103
#define BH_PLUS_OPTION_MICRSTATUS         104
#define BH_PLUS_OPTION_MICRPOSTREAD       105
#define BH_PLUS_OPTION_PRNSETUP_SZ        106
#define BH_PLUS_OPTION_PRNINIT_SZ         107
#define BH_PLUS_OPTION_PRNPREPRINT_SZ     108
#define BH_PLUS_OPTION_PRNHDR_SZ          109
#define BH_PLUS_OPTION_PRNITEM_SZ         110
#define BH_PLUS_OPTION_PRNTRANSSUM_SZ     111
#define BH_PLUS_OPTION_PRNPAYSUM_SZ       112
#define BH_PLUS_OPTION_PRNFOOTER_SZ       113
#define BH_PLUS_OPTION_PRNPOSTPRINT_SZ    114
#define BH_PLUS_OPTION_JRNPREPRINT_SZ     115
#define BH_PLUS_OPTION_JRNITEM_SZ         116
#define BH_PLUS_OPTION_JRNPOSTPRINT_SZ    117
#define BH_PLUS_OPTION_ENDPREPRINT_SZ     118
#define BH_PLUS_OPTION_ENDITEM_SZ         119
#define BH_PLUS_OPTION_ENDPOSTPRINT_SZ    120
#define BH_PLUS_OPTION_LBLPREPRINT_SZ     121
#define BH_PLUS_OPTION_LBLITEM_SZ         122
#define BH_PLUS_OPTION_LBLPOSTPRINT_SZ    123
#define BH_PLUS_OPTION_SLIPPREPRINT_SZ    124
#define BH_PLUS_OPTION_SLIPHEADER_SZ      125
#define BH_PLUS_OPTION_SLIPITEM_SZ        126
#define BH_PLUS_OPTION_SLIPFOOTER_SZ      127
#define BH_PLUS_OPTION_SLIPPOSTPRINT_SZ   128
#define BH_PLUS_OPTION_CHKPREPRINT_SZ     129
#define BH_PLUS_OPTION_CHKITEM_SZ         130
#define BH_PLUS_OPTION_CHKPOSTPRINT_SZ    131
#define BH_PLUS_OPTION_MICRPREREAD_SZ     132
#define BH_PLUS_OPTION_MICRREAD_SZ        133
#define BH_PLUS_OPTION_MICRSTATUS_SZ      134
#define BH_PLUS_OPTION_MICRPOSTREAD_SZ    135
#define BH_PLUS_OPTION_ACCDEFTAX          136
#define BH_PLUS_OPTION_ACCRETURNS         137
#define BH_PLUS_OPTION_ACCRENTAL          138
#define BH_PLUS_OPTION_ACCLAYBY           139
#define BH_PLUS_OPTION_CLIENTRESETTIME    140
#define BH_PLUS_OPTION_TRANSPREFIX        141
#define BH_PLUS_OPTION_TOKENBCPREFIX      142
#define BH_PLUS_OPTION_VOUCHERBCPREFIX    143
#define BH_PLUS_OPTION_COUPONBCPREFIX     144
#define BH_PLUS_OPTION_CUSTOMERBCPREFIX   145
#define BH_PLUS_OPTION_CACHEPB            146
#define BH_PLUS_OPTION_CACHEPBLIMIT       147
#define BH_PLUS_OPTION_CUSTDISPPRESALE    150
#define BH_PLUS_OPTION_CUSTDISPPRESALE_SZ 151
#define BH_PLUS_OPTION_CUSTDISPPOSTSALE   152
#define BH_PLUS_OPTION_CUSTDISPPOSTSALE_SZ 153
#define BH_PLUS_OPTION_CUSTDISPIDLE       154
#define BH_PLUS_OPTION_CUSTDISPIDLE_SZ    155
#define BH_PLUS_OPTION_SERVERSIDE         156
#define BH_PLUS_OPTION_SERVERTARGETS      157
#define BH_PLUS_OPTION_SERVERMENU         158
#define BH_PLUS_OPTION_CURRRNDTYPE        159
#define BH_PLUS_OPTION_DBSOURCE           160
#define BH_PLUS_OPTION_ACCDEFSALE         161

// parms
#define BH_PLUS_PARM_NUMCLIENTS        1
#define BH_PLUS_PARM_NUMOPENTRANS      2
#define BH_PLUS_PARM_CURRLOAD          3
#define BH_PLUS_PARM_MAXLOAD           4
#define BH_PLUS_PARM_CURRTIME          5
#define BH_PLUS_PARM_STARTTIME         6
#define BH_PLUS_PARM_UPTIME            7
#define BH_PLUS_PARM_MSGCOUNT          8
#define BH_PLUS_PARM_TOTALMSG          9
#define BH_PLUS_PARM_CLEARDB           10
#define BH_PLUS_PARM_CLEARCCV          11
#define BH_PLUS_PARM_CLEARCI           12
#define BH_PLUS_PARM_NUMCLIENTACK      13

// client info params
#define BHRET_TYPE_BASE         0x00000001
#define BHRET_TYPE_SALE        (BHRET_TYPE_BASE << 0)
#define BHRET_TYPE_PAY         (BHRET_TYPE_BASE << 1)
#define BHRET_TYPE_RETURNS     (BHRET_TYPE_BASE << 2)
#define BHRET_TYPE_LAYBYS      (BHRET_TYPE_BASE << 3)
#define BHRET_TYPE_RENTALS     (BHRET_TYPE_BASE << 4)
#define BHRET_TYPE_ALL          0xFFFFFFFF

// trans ret flags
#define CLIENTINFO_MACADDRESS    1

//threads
#define THREAD_RUNNING           0
#define THREAD_DEAD              1

#define THREAD_PARAM_STATE       1
#define THREAD_PARAM_RSCOUNT     2
#define THREAD_PARAM_NORS        3
#define THREAD_PARAM_DEATH       4
#define ALL_THREADS              0xFFFFFFFF

#define INQ_THREAD     0x00000001
#define OUTQ_THREAD    0x00000002
#define SQLQ_THREAD    0x00000004
#define CTRLQ_THREAD   0x00000008
#define ERRQ_THREAD    0x00000010
#define UDP_THREAD     0x00000020
#define IDLE_THREAD    0x00000040
#define TRANSQ_THREAD  0x00000080
#define RPRINTQ_THREAD 0x00000100
#ifdef _CCVENGINEMCVE   
#define CCVQ_THREAD    0x00000200
#endif

#define INQ_THREADID      0
#define OUTQ_THREADID     1
#define SQLQ_THREADID     2
#define CTRLQ_THREADID    3
#define ERRQ_THREADID     4
#define UDP_THREADID      5
#define IDLE_THREADID     6
#define TRANSQ_THREADID   7
#define RPRINTQ_THREADID  8
#ifdef _CCVENGINEMCVE   
#define CCVQ_THREADID     9
#endif

typedef struct tagbhthread{
   pthread_t      thread;
   unsigned char  status;
   unsigned char  restart_count;
   unsigned char  norestart;
   unsigned char  die;
}bhthread;

typedef struct tagrprnlist{
   unsigned char  status;
   short          type;
   char           host[33];
   char           name[32];
}rprnlist;

class PLUServer{
private:
   bool  bPlugandPlay;

   // general options crap
   int    status;
   bool   bModule;
   bool   bUDP;
   bool   bTCP;
   bool   bMulticast;
   bool   bDaemon;
   bool   bCachedPlu;
   bool   bCachedPb;
   int    plucachelimit;
   int    pbcachelimit;
   int    bPreCached;
   int    currencyrndtype;
   
   bool   bCanShutdown;
   int    shutdownt;

   bool  bhaveUPS;
   bool  bNetworkUPS;
   char *ups_host;
   unsigned short ups_port;
   int  ups_period;
   bool bClientUPSCollect;
   int  clientupsperiod;
   int  client_reset_time;
   
   int    ccvauthpolicy;
   double ccvauthamount;
   
   int   def_saleaccount;
   int   def_taxaccount;
   int   def_returnsaccount;
   int   def_laybyaccount;
	int   def_rentalsaccount;
   char *def_transprefix;
   
   bool  bErrRedirect;
   int   err_retries;
   int   err_timeout;
   
   bool bPluandPlay;
   bool bServerSide;
   bool bServerTargets;
   bool bServerMenu;
   
   bool           bRemotePrinter;
   std::list<rprnlist> printers;

   bool  bMultipleDb;
   char *dbsource;
   char *dbhost;
   char *dbname;
   char *dbuser;
   char *dbpassword;
   char *precached_tablename;
   char *sqlfile;
   bool  bUseDefaultCash;

   // specific options crap
   bool   bkeepalive;
   int    alivetime;
   int    aliveretries;
   int    basecurrencyID;
   char  *modulesdir;
   int    addressRange;
   bool   bfilterHosts;
   int    loglevel;
   int    idleupdateperiod;
   int    threadupdateperiod;
   int    procwriterperiod;
   int    transrecommitupdate;
   int    statsupdate;
   
   char   int_bcprefix[3];
   int    weight_bcprefix;
   int    quantity_bcprefix;
   int    price_bcprefix;
   int    interface_bcprefix;
   int    token_bcprefix;
   int    voucher_bcprefix;
   int    customer_bcprefix;
   int    instore_bcprefix;
   
   int    baselocaleID;
   char  *baselocale;
   bhpos::CLocale  locale;

   GlobalPrint   globalprint;

   char *ccvhost;
   char *ccvsslhost;
   unsigned short ccvport;
   unsigned short ccvsslport;
   char *ccvusername;
   char *ccvpassword;
   char *ccvcertificate;
   unsigned int ccvconntypes;
   unsigned int ccvdefaultconn;

   int address_size;
   int i, len;
   
   // stats crap
   clock_t  start_time, curr_time;
   unsigned long up_time;
   double   max_load;
   double   curr_load;
   int      min_time;
   int      max_time;
   clock_t  msg_elapsed_time;
   
   // live forever crap
#ifndef _DEBUGGERY
   FILE *azfd;
   int   azblock[2];
#endif
   
protected:
   sockaddr_in6 udp_addr;
   sockaddr_in6 tcp_addr;
   sockaddr_in  udp_addr4;
   sockaddr_in  tcp_addr4;
   
   CTCPThread      tcpthr;
   int             listener_sock;
   char            host[32];
   unsigned short  port;
   char            ctrl_host[32];
   unsigned short  ctrl_port;
   char            err_host[32];
   unsigned short  err_port;
   
   bhthread thread[9];
   
   bhpos::service::CClientAckCollector client_collector;

   pthread_mutex_t  mutex;

   // options
   int   mode;
   bool  bEncryptedHeader;
   
   // status gear
   int   num_connected;
   int   error;
   int   sessionStatus;
   std::list<bhpos::CClientInfo>   clients;
   
   // plugins..
   bool bHasModules; 
   bhpos::CModuleCollection   *modules;
   
public:
   PLUServer();
   ~PLUServer(); // closes sockets, etc.
   bool CanShutdown();
   int  ShutdownIn(int);
   void BigCrunch(bool);
   int RestartThreads(bool bForce);

   int  SetOption(int, void *);
   int  GetOption(int, void *);
   int  GetParameter(int p, void *v);
   int  SetParameter(int p, void *v);
   int  AdjParameter(int p);
   void SetPlugAndPlay(bool b){ bPlugandPlay=b; }
   bool IsPlugAndPlay(){ return bPlugandPlay; }
   int  ModuleScan();
   int  LibLoad();
   int  Run();

   void KeepAlive();

   int  SetMode(int mode);
   int  GetMode();
   bool CanWrite(int);
   bool IsError(int);
   int  GetStatus(){ return status; }
   
   //bool HdrOK(BhHdr *hdr);
   //bool AddressOK(sockst *addr);
   //bool CheckMessage(BhPosMsg *);
   bool AddClient(bhpos::CClientInfo& c, BhPosMsg *msg);
   bool GetClient(int, bhpos::CClientInfo& c);
   bool DeleteClient(bhpos::CClientInfo&);
   bool ClientExists(bhpos::CClientInfo& c, BhPosMsg *msg);
   bool UpdateClient(bhpos::CClientInfo&);
   int  GetClientInfo(int, unsigned int, void *);
   void ClientAck(int);
   void ResetClients();
   bool FillClientList(bhpos::service::CClientAckCollector& ac);

   static int QueueExists(bhpos::BhModQ);
   static int QueueAdd(bhpos::BhModQ, BhPosMsg *);
   
   bool HasModules();
   bool ModuleHandlesMessages(int);
   int  HandleMsg(BhPosMsg *);

   int Lock();
   int Release();
   
   int SetThread(unsigned int, int , void *);
   int GetThread(unsigned int, int , void *);
   
   int CreateListener();
   int GetListener();
   
   int CheckThreads(unsigned int);
   
   unsigned int   msg_count;
   unsigned int   total_msg;
   bhpos::CServSideTransStack ssts;
   
protected:
   int CreateThread(unsigned int);
   void CancelThreads(bool);
   int JoinThreads();
   int CheckQueues(int);
   int ParseString(char *, char *);
      
private:
   int WillAccept(int fd);
   void BhError(int type, char *msg);
   int ReadAllowedHostsFile();
   int SetUpGrammy();
      
   int TxBhCtrlMsg(char *, int);
   int SetPOSTState(int s, int t, int v); 
};

#endif
